/* GLSL_multilight: different methods to display multiple lights, using plain GL, GLSL shaders or deferred shading
   Copyright (C) 2008 Angelo "Encelo" Theodorou
*/

#define NUM_LIGHTS 3
#define NUM_SHADERS 6
#define SHADERS_DIR "shaders/"
struct Shaders {
	GLuint vert[NUM_SHADERS], frag[NUM_SHADERS];
    GLuint p[NUM_SHADERS];
};

struct FBO {
	GLuint frame, depth, texid[3];
	int width, height;
};

struct Material {
	GLfloat ambient[4];
	GLfloat specular[4];
	GLfloat shininess;
};



void InitLighting(struct Material *m);
void InitFBOs(struct FBO *fbo);
void DeleteFBOs(struct FBO *fbo);
void InitShaders(struct Shaders *sh);
void DeleteShaders(struct Shaders *sh);
GLuint LoadTexture(char *file);
