uniform sampler2D Tex0, Tex1, Tex2;

void main(void)
{
	vec4 colorMap, ambientGlobal, ambient, diffuse;
    vec3 ecPos, n, aux, lightDir, halfVector;
    float NdotL, NdotHV, dist, att;

	ecPos = texture2D(Tex0, gl_TexCoord[0].st).xyz;
	n = texture2D(Tex1, gl_TexCoord[1].st).xyz;
	colorMap = texture2D(Tex2, gl_TexCoord[2].st);

	ambientGlobal = gl_LightModel.ambient * gl_FrontMaterial.ambient;

	aux = gl_LightSource[0].position.xyz - ecPos;
	dist = length(aux);
	lightDir = normalize(aux);

	att = 1.0 / (gl_LightSource[0].constantAttenuation +
				gl_LightSource[0].linearAttenuation * dist +
				gl_LightSource[0].quadraticAttenuation * dist * dist);

	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;

	gl_FragColor = ambientGlobal + ambient * att;

	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	NdotL = max(dot(n, lightDir), 0.0);

	if (NdotL > 0.0) {
		gl_FragColor += att * (diffuse * NdotL);
		halfVector = normalize(lightDir + normalize(ecPos));
		NdotHV = max(dot(n, halfVector), 0.0);
		gl_FragColor += att * gl_FrontMaterial.specular * gl_LightSource[0].specular * pow(NdotHV, gl_FrontMaterial.shininess);
	}

	gl_FragColor *= colorMap;
}
