varying vec3 normal, ecPos;
varying vec4 ambientGlobal, ambient, diffuse;
uniform sampler2D Tex0;

void main (void)
{
	vec3 n, aux, lightDir, halfVector;
	float NdotL, NdotHV;
	float dist, att;

	vec4 colorMap = texture2D(Tex0, gl_TexCoord[0].st);

	n = normalize(normal);
	aux = gl_LightSource[0].position.xyz - ecPos;
    dist = length(aux);
    lightDir = normalize(aux);

	att = 1.0 / (gl_LightSource[0].constantAttenuation +
                 gl_LightSource[0].linearAttenuation * dist +
                 gl_LightSource[0].quadraticAttenuation * dist * dist);

	gl_FragColor = ambientGlobal + ambient * att;

	NdotL = max(dot(n, lightDir), 0.0);

	if (NdotL > 0.0) {
		gl_FragColor += att * (diffuse * NdotL);
		halfVector = normalize(lightDir + normalize(ecPos));
		NdotHV = max(dot(n, halfVector), 0.0);
		gl_FragColor += att * gl_FrontMaterial.specular * gl_LightSource[0].specular * pow(NdotHV, gl_FrontMaterial.shininess);
	}

	gl_FragColor *= colorMap;
}
