varying vec4 intensity;

void main(void)
{
	vec4 ambientGlobal, ambient, diffuse;
	vec3 ecPos, normal, lightDir, halfVector, aux;
    float NdotL, NdotHV, dist, att;

	ecPos = vec3(gl_ModelViewMatrix * gl_Vertex);
	normal = normalize(gl_NormalMatrix * gl_Normal);
	aux = gl_LightSource[0].position.xyz - ecPos;
	dist = length(aux);
	lightDir = normalize(aux);

	att = 1.0 / (gl_LightSource[0].constantAttenuation +
				 gl_LightSource[0].linearAttenuation * dist +
				 gl_LightSource[0].quadraticAttenuation * dist * dist);

	ambientGlobal = gl_LightModel.ambient * gl_FrontMaterial.ambient;
    ambient = gl_LightSource[0].ambient * gl_FrontMaterial.ambient;

	intensity = ambientGlobal + ambient * att;

	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
    NdotL = max(dot(normal, lightDir), 0.0);

    if (NdotL > 0.0) {
		halfVector = normalize(lightDir + normalize(ecPos));
        intensity += att * (diffuse * NdotL);
        NdotHV = max(dot(normal, halfVector), 0.0);
        intensity += att * gl_FrontMaterial.specular * gl_LightSource[0].specular * pow(NdotHV, gl_FrontMaterial.shininess);
    }

	gl_Position = ftransform();
	gl_TexCoord[0] = gl_MultiTexCoord0;
}
